#
#  Copy model specific CamData files from a new release
#

proc copynew { from } {
  set all [lsort [glob $from/ApnCamData_*.h]]
  set fcc [open models.mak w]
  set fsm [open SupportedModels.txt w]
  set finc [open ApnCamData_models.h w]
  set fmin [open ../../FILES-MINIMAL w]
  puts $fmin "/opt/apogee/HISTORY
/opt/apogee/COPYING
/opt/apogee/README-MINIMAL
/opt/apogee/config
/opt/apogee/doc/user-guide.pdf
/opt/apogee/include
/opt/apogee/scripts
/opt/apogee/src/ccd
/opt/apogee/src/apogee/makefile
/opt/apogee/src/apogee/models.mak
/opt/apogee/src/apogee/maketdi
/opt/apogee/src/apogee/maketest
/opt/apogee/src/apogee/Apn.h
/opt/apogee/src/apogee/ApnCamData.h
/opt/apogee/src/apogee/ApnCamTable.h
/opt/apogee/src/apogee/ApnCamera.h
/opt/apogee/src/apogee/ApnCamera_NET.h
/opt/apogee/src/apogee/ApnCamera_USB.h
/opt/apogee/src/apogee/ApnFilterWheel.h
/opt/apogee/src/apogee/ApnSerial.h
/opt/apogee/src/apogee/ApnSerial_NET.h
/opt/apogee/src/apogee/ApnSerial_USB.h
/opt/apogee/src/apogee/ApnUsbSys.h
/opt/apogee/src/apogee/Apogee.h
/opt/apogee/src/apogee/ApogeeLinux.h
/opt/apogee/src/apogee/CameraIO_Linux.h
/opt/apogee/src/apogee/CameraIO_PCI.h
/opt/apogee/src/apogee/apogee-test.h
/opt/apogee/src/apogee/dbt.h
/opt/apogee/src/apogee/stdafx.h
/opt/apogee/src/apogee/apogeeISA_wrap.c
/opt/apogee/src/apogee/apogeeNET_wrap.c
/opt/apogee/src/apogee/apogeePCI_wrap.c
/opt/apogee/src/apogee/apogeePPI_wrap.c
/opt/apogee/src/apogee/apogeeUSB_wrap.c
/opt/apogee/src/apogee/filterUSB_wrap.c
/opt/apogee/src/apogee/serialNET_wrap.c
/opt/apogee/src/apogee/serialUSB_wrap.c
/opt/apogee/src/apogee/ApnCamera.i
/opt/apogee/src/apogee/ApnFilterWheel.i
/opt/apogee/src/apogee/ApnSerial.i
/opt/apogee/src/apogee/apogeeISA.i
/opt/apogee/src/apogee/apogeeLinux.i
/opt/apogee/src/apogee/apogeeNET.i
/opt/apogee/src/apogee/apogeePCI.i
/opt/apogee/src/apogee/apogeePPI.i
/opt/apogee/src/apogee/apogeeUSB.i
/opt/apogee/src/apogee/filterUSB.i
/opt/apogee/src/apogee/serialNET.i
/opt/apogee/src/apogee/serialUSB.i
/opt/apogee/src/apogee/ApnCamData.cpp
/opt/apogee/src/apogee/ApnCamTable.cpp
/opt/apogee/src/apogee/ApnCamera.cpp
/opt/apogee/src/apogee/ApnCamera_Linux.cpp
/opt/apogee/src/apogee/ApnCamera_NET.cpp
/opt/apogee/src/apogee/ApnCamera_USB.cpp
/opt/apogee/src/apogee/ApnFilterWheel.cpp
/opt/apogee/src/apogee/ApnSerial.cpp
/opt/apogee/src/apogee/ApnSerial_NET.cpp
/opt/apogee/src/apogee/ApnSerial_USB.cpp
/opt/apogee/src/apogee/BulkTDI.cpp
/opt/apogee/src/apogee/CameraIO_Linux.cpp
/opt/apogee/src/apogee/CameraIO_LinuxISA.cpp
/opt/apogee/src/apogee/CameraIO_LinuxPCI.cpp
/opt/apogee/src/apogee/CameraIO_LinuxPPI.cpp
/opt/apogee/src/apogee/CameraIO_PCI.cpp
/opt/apogee/src/apogee/Camera_Example.cpp
/opt/apogee/src/apogee/testTDI.cpp
/opt/apogee/src/apogee/testTDIu.cpp
/opt/apogee/src/apogee/test_alta.cpp
/opt/apogee/src/apogee/test_apogee.cpp
/opt/apogee/src/apogee/testnet.cpp
/opt/apogee/src/apogee/ApogeeNet/ApogeeNet.h
/opt/apogee/src/apogee/ApogeeNet/ApogeeNetErr.h
/opt/apogee/src/apogee/ApogeeNet/ApnDiscover.cpp
/opt/apogee/src/apogee/ApogeeNet/ApogeeNet.cpp
/opt/apogee/src/apogee/ApogeeNet/ApogeeNetLinux.cpp
/opt/apogee/src/apogee/ApogeeUsb/ApogeeUsb.h
/opt/apogee/src/apogee/ApogeeUsb/ApogeeUsbErr.h
/opt/apogee/src/apogee/ApogeeUsb/usb.h
/opt/apogee/src/apogee/ApogeeUsb/ApogeeUsbLinux.cpp
/opt/apogee/src/apogee/ApogeeNet/ApogeeNet.h
/opt/apogee/src/apogee/ApogeeNet/ApogeeNetErr.h
/opt/apogee/src/apogee/FpgaRegs/FpgaRegs.h"
  puts $fcc "#
# ApnCamData Sources, Objects, CamData target
#
SRCS_CAMDATA = \\
	ApnCamData.cpp \\"
  exec cp $from/ApnCamData.cpp .
  exec cp $from/ApnCamData.h .
  exec cp $from/ApnCamTable.cpp .
  exec cp $from/ApnCamTable.h .
  foreach i $all { 
      set model [string trim [string range [file tail $i] 11 end] ".h"]
      puts $fsm "$model"
      puts $fcc "	ApnCamData_$model.cpp \\"
      puts $fmin "/opt/apogee/src/apogee/ApnCamData_$model.h"
      puts $fmin "/opt/apogee/src/apogee/ApnCamData_$model.cpp"
      puts $finc "#include \"ApnCamData_$model.h\""
      exec cp $from/ApnCamData_$model.h .
      exec cp $from/ApnCamData_$model.cpp .
      puts stdout "Processed $model"
  }
  puts $fcc "	ApnCamTable.cpp

OBJS_CAMDATA = \$(SRCS_CAMDATA:.cpp=.o)

CamData: \$(OBJS_CAMDATA)

"
  close $fcc
  close $fsm
  close $finc
  close $fmin
  set all [lsort [glob ApnCamData_*.h]]
  foreach i $all { 
    set fap [open $i a]
    puts $fap " "
    close $fap 
    puts stdout "done $i"
  }
}


proc usecurrent { } {
  set all [lsort [glob ApnCamData_*.h]]
  set fcc [open models.mak w]
  set fsm [open SupportedModels.txt w]
  puts $fcc "
CamData:
	\$(CC) \$(CPPFLAGS) -c ApnCamData.cpp
	\$(CC) \$(CPPFLAGS) -c ApnCamTable.cpp"
  foreach i $all { 
      set model [string trim [string range [file tail $i] 11 end] ".h"]
      puts $fsm "$model"
      puts $fcc "	\$(CC) \$(CPPFLAGS) -c ApnCamData_$model.cpp"
      puts stdout "Processed $model"
  }
  puts $fcc " "
  close $fcc
  close $fsm
}


